#MP ;--------------- Macros visible to Application ------------------
                      #MP
#MP Macro BeginNames
#MP Lindex = 0 ;Label index
#MP Total = 0
#MP maxlen = 0
#MP Endm
                      #MP
#MP Macro AddString ;(string)
#MP Setstr STR_%dLindex = #1#
#MP Setstr STRx_%dLindex = #1#
#MP len = Ustrlen(#1#)
#MP If maxlen < len
#MP     maxlen = len
#MP Endif
#MP Total = Total + len
#MP Lindex = Lindex+1
#MP Endm
                      #MP
#MP Macro EndNames
#MP RemoveFluff
#MP ComputeAllOverlaps
#MP GreedyMerge
#MP Concatenate
#MP CLength
#MP CIndex
#MP CSuper
#MP Endm
                      #MP
                      #MP
#MP ;----------------- Remove substrings from the set --------------------
#MP Macro RemoveFluff ;()
#MP MaxIndex = Lindex - 1
#MP For i=0, MaxIndex
#MP   For j=0, MaxIndex
#MP     If i!=j
#MP        Setstr dummy = {uSplit, STR_%uj, STR_%ui}
#MP        If uSplit>=0
#MP          If i != MaxIndex ;not last string: compact the array
#MP            Setstr STR_%ui = STR_%uMaxIndex
#MP            i = i - 1 ;force re-examining the same string index
#MP          Endif
#MP          Undef STR_%uMaxIndex
#MP          MaxIndex = MaxIndex - 1
#MP          j = Lindex ;break the inner loop
#MP       Endif
#MP      Endif
#MP    Endfor
#MP    If i>=MaxIndex
#MP      i = Lindex ;(manually) break the (reduced) loop
#MP    Endif
#MP Endfor
#MP Endm
                      #MP
#MP Macro Concatenate
#MP Setstr SuperString = ""
#MP For i=0, MaxIndex
#MP     Ifdef STR_%ui
#MP         Setstr SuperString = SuperString + STR_%ui
#MP     Endif
#MP Endfor
#MP SuperString = Ustrlen(SuperString)
#MP Endm
                      #MP
                      #MP
#MP ;------------- Compute overlap information ----------------------- 
#MP Macro ComputeAllOverlaps
#MP maxmatchlen = 0
#MP For i=0, MaxIndex
#MP   MergeBase%ui = i ;no redirection yet
#MP   Setstr str2 = STR_%ui
#MP   Setstr FirstLetter = {uSubstr, STR_%ui, 0, 1}
#MP   For j=0, MaxIndex
#MP     If i!=j
#MP        Setstr str1 = STR_%uj
#MP        ComputeOverlap[]
#MP     Endif
#MP   Endfor
#MP Endfor
#MP Endm
                      #MP
#MP Macro ComputeOverlap ;a helper: could be inlined
        #MP  Repeat
        #MP    Setstr dummy = {uSplit, str1, FirstLetter}
        #MP    If uSplit>=0 ;match found
        #MP      Setstr str1 = {uSubstr, str1, str1-1, Total} ;match to test
        #MP      matchlen = Ustrlen(str1)
        #MP      Setstr dummy = {uSplit, str2, str1}
        #MP      If uSplit>=0 && matchlen == str2
        #MP        ProcessOverlap[]
        #MP        uSplit = -1 ;break
        #MP      Else
        #MP        Setstr str1 = {uSubstr, str1, 1, Total}
        #MP        uSplit = 1 ;continue
        #MP      Endif
        #MP    Endif
        #MP  While uSplit>=0
#MP Endm
                      #MP
#MP Macro ProcessOverlap ;actually records an overlap found
#MP        count = 0
#MP        Ifdef count_%08Xmatchlen%08Xj
#MP          count = count_%08Xmatchlen%08Xj
#MP        Endif
#MP;[#mp%uj]="#mp%sSTR_%uj" (#mp%umatchlen) [#mp%ui]="#mp%sSTR_%ui"
#MP        match%08Xmatchlen%08Xj%ucount = i;
#MP        count_%08Xmatchlen%08Xj = count + 1
#MP         If matchlen > maxmatchlen
#MP             maxmatchlen = matchlen
#MP         Endif
#MP Endm
                      #MP
#MP ;------------------------ Greedy merge ---------------------------- 
#MP Macro GreedyMerge
#MP For xx = 0, maxmatchlen-1
#MP     matchlen = maxmatchlen - xx ;make it a descending order
#MP     MergeStrings[]
#MP Endfor
#MP Endm
                      #MP
#MP Macro MergeStrings ;does all merges for overlap length `matchlen'
#MP For i = 0, MaxIndex
#MP   Ifdef STR_%ui
#MP     bm = MergeBase%ui
#MP     If Defined(count_%08Xmatchlen%08Xbm)
#MP       For co = 0, count_%08Xmatchlen%08Xbm-1
#MP         j = match%08Xmatchlen%08Xbm%uco
#MP         If j != i
#MP           Ifdef STR_%uj ;then it's our best match: merge to i
        #MP     Setstr tail = {uSubstr, STR_%uj, matchlen, Total}
        #MP     Setstr STR_%ui = STR_%ui + tail ;new string
        #MP     MergeBase%ui = MergeBase%uj
        #MP     Undef STR_%uj
        #MP     co = 0x7fffffff ;break the inner loop
        #MP     i = i-1 ;repeat with merged string
#MP           Endif
#MP         Endif
#MP       Endfor
#MP     Endif
#MP   Endif
#MP Endfor
#MP Endm
#MP ;------------------------ Pretty printing ---------------------------- 
#MP Macro PrettyPrintStringAsHex ;(encoded-string, bytes-per-line)
#MP Set line 0
#MP Repeat
#MP     Setstr line = ""
#MP     index = line*#2#
#MP     For b = 0, #2#-1
#MP         ix = index + b
#MP         Setstr let = {uSubstr, #1#, ix, ix+1}
#MP         If Ustrlen(let) == 0
#MP             b = #2# ;break the loop
#MP         Else
#MP             let = LETTER_%slet
#MP             Setstr line = line + "0x" + {%02xlet} + ","
#MP         Endif
#MP     Endfor
    /*[#mp%03uindex]*/ #mp%sline
#MP     Set line line+1
#MP While Ustrlen(let) != 0
#MP Endm
                      #MP
#MP ;---------------- Target charset encoding --------------------- 
#MP Macro EncodeString
#MP Setstr result = ""
#MP For i=0, Ustrlen(#1#)-1
#MP   Setstr t = {uSubstr,#1#,i,i+1} ;`character' #i of original string
#MP   Setstr result = result + [LETTER_%st]
#MP Endfor
#MP Endm
                      #MP
#MP ;---------------- C tables generators ------------------------- 
#MP Macro CLength
const unsigned char length[#mp%uLindex] =
{
#MP For i=0,Lindex-1
#MP   len = Ustrlen(STRx_%ui)
  [#mp%ui] = #mp{%ulen}U, //length of "#mp%sSTRx_%ui"
#MP  Endfor
};
#MP Endm
                      #MP
#MP Macro CIndex
const unsigned short index[#mp%uLindex] =
{
#MP For i=0,Lindex-1
#MP    Setstr dummy = {uSplit, SuperString, STRx_%ui}
#MP    ix = SuperString - Ustrlen(STRx_%ui)
  [#mp%ui] = #mp{%uix}U, //index of "#mp%sSTRx_%ui"
#MP  Endfor
};
#MP Endm
                      #MP
#MP Macro CSuper
const unsigned char SuperString[] =
{
#MP EncodeString(SuperString)
#MP PrettyPrintStringAsHex(result, 10)
};
#MP Endm
                      #MP
#MP ;---------------- <END> ------------------------- 
